% Beregner og plotter simulert punktkilde
clf

zh = 0.018;
dx = 0.022725;

dz = dx/10;
f = 5000; % !!!
lambda = 340/f;

ph = zeros(12,12);
for x=-5:6
for y=-5:6
    r = sqrt(zh^2 + (x*dx)^2  + (y*dx)^2);
    ph(x+6,y+6) = 1*exp(-1i*2*pi*r/lambda)/r +0.1*rand*exp(-1i*2*pi*r/lambda)/r;
end
end

c = 340; 
p0 = 1.21;
Lx = 13*dx; % (N+1)*dx
Ly = 13*dx; % (N+1)*dy
Nx = 24; % Antall punkter i x-retning. (2x antall maalepunkter)
Ny = 24; % Antall punkter i y-retning. (2x antall maalepunkter)
Nz = 100; % Antall plan i z-retning

% Oppretter ymse beregningsvariabler
dim = [Nx Nx Nz];
ps = zeros(Nx,Ny);
vs = zeros(Nx,Ny);
Ps = zeros(Nx,Ny);
Vs = zeros(Nx,Ny);
H = zeros(Nx,Ny);

% Kantfilter
W =  tukeywin(Nx/2,.3)*tukeywin(Ny/2,.3)';
H(7:18,7:18)=ph.*W;
H_fft2(:,:) = (fft2(H(:,:),24,24));

    for x=-Ny/2:Nx/2-1
    for y=-Ny/2:Ny/2-1

       kx = 2*pi*x/Lx; 
       ky = 2*pi*y/Ly;
       k = 2*pi*f/c;
       
       % Setter verdier for k-romsfilteret
       kr = sqrt(kx^2 + ky^2);
       kc = 0.6*12*pi/Lx;
       a = 0.2;
       
       % Finner verdi for kz
        if k^2 >= (kx^2 + ky^2)
            kz = sqrt(k^2 - kx^2 - ky^2);
        else
            kz = 1i*sqrt(ky^2 + kx^2 - k^2);
        end
        
       % k-romsfilter
        if abs(kr) <= kc
            Wk = 1 - 0.5*exp((kr/kc - 1)/a);
        elseif abs(kr) > kc
            Wk = 0.5*exp((1 - kr/kc)/a);
        else
            Wk = 1;
        end
        
        % Zero-padding av Greensfunksjon
        if (x>=-6 && x<=5) && (y>=-6 && y<=5)
            Gp = exp(1i*kz*zh);
            Gv = (1/(p0*c*k))*exp(1i*kz*zh);
        else
            Gp = 0;
            Gv = 0;
        end
              
        Ps(x+1+(Nx/2),y+1+(Ny/2)) = H_fft2(x+1+(Nx/2),y+1+(Ny/2)).*Gp.*Wk;
        Vs(x+1+(Nx/2),y+1+(Ny/2)) = H_fft2(x+1+(Nx/2),y+1+(Ny/2)).*Gv.*Wk;
       
       %[thet,phi,r] = cart2sph(x,y,zh);
       %Ds(x+1+(Nx/2),y+1+(Ny/2)) = k*cos(thet)*H_fft2(x+1+(Nx/2),y+1+(Ny/2))*1i*exp(-1i*k*cos(zh));
       
    end
    end
    ps(:,:) = ifft2((Ps(:,:)),Nx,Ny); % Trykk ved kilden
    vs(:,:) = ifft2((Vs(:,:)),Nx,Ny); % Partikkelhastighet ved kilden i z-retning
    %ds(:,:) = ifft2((Ds(:,:)),Nx,Ny);

is = real(ps.*conj(vs))/2; % Intensitet ved kilden i z-retning

% figure(1)
% surf(10*log10(is))
% axis equal
% axis square
% 

% figure(5)
% plot(is(:,13),'-o')
% axis equal
% axis square

pz = zeros(dim);
vx = zeros(dim);
vy = zeros(dim);
vz = zeros(dim);
Pz = zeros(dim);
Vx = zeros(dim);
Vy = zeros(dim);
Vz = zeros(dim);

% Regner ut verdier for hvert enkelt z-plan
for z=1:Nz
    zi = z*dz; % Fysisk h?yde over planet
    for x=-Nx/2:Nx/2-1
    for y=-Ny/2:Ny/2-1
       kx = 2*pi*x/Lx;
       ky = 2*pi*y/Ly;
       k = 2*pi*f/c;
       
       % Setter verdier for k-romsfilteret
       kr = sqrt(kx^2 + ky^2);
       kc = 0.6*12*pi/Lx;
       a = 0.2;
       
        % Finner verdi for kz
        if k^2 >= (kx^2 + ky^2)
             kz = sqrt(k^2 - kx^2 - ky^2);
        else
             kz = 1i*sqrt(ky^2 + kx^2 - k^2);
        end
        
        % k-romsfilter
        if abs(kr) <= kc
             Wk = 1 - 0.5*exp((kr/kc - 1)/a);
        elseif abs(kr) > kc
             Wk = 0.5*exp((1 - kr/kc)/a);
        else
             Wk = 1;
        end
        
        % Zero-padding av Greensfunksjon
        if (x>=-6 && x<=5) && (y>=-6 && y<=5)
            Gp = exp(1i*kz*(zi));
            Gv = (1/(p0*c*k))*exp(1i*kz*(zi));
        else
            Gp = 0;
            Gv = 0;
        end
        
       Pz(x+1+(Nx/2),y+1+(Ny/2),z) = Ps(x+1+(Nx/2),y+1+(Ny/2)).*Gp.*Wk;
       Vz(x+1+(Nx/2),y+1+(Ny/2),z) = Ps(x+1+(Nx/2),y+1+(Ny/2)).*kz.*Gv.*Wk;
       Vx(x+1+(Nx/2),y+1+(Ny/2),z) = Ps(x+1+(Nx/2),y+1+(Ny/2)).*kx.*Gv.*Wk;
       Vy(x+1+(Nx/2),y+1+(Ny/2),z) = Ps(x+1+(Nx/2),y+1+(Ny/2)).*ky.*Gv.*Wk;
       
    end
    end
    pz(:,:,z) = ifft2((Pz(:,:,z)),Nx,Ny);
    vz(:,:,z) = ifft2((Vz(:,:,z)),Nx,Ny);
    vx(:,:,z) = ifft2((Vx(:,:,z)),Nx,Ny);
    vy(:,:,z) = ifft2((Vy(:,:,z)),Nx,Ny);
end

z_mat = 1:5:100;
x_mat = 1:1:24;
[X,Z] = meshgrid(z_mat,x_mat);

ix = real(pz.*conj(vx))/2;
iz = real(pz.*conj(vz))/2;
ixz = sqrt(ix.^2+iz.^2);

figure(2)
hold on
h=surf((squeeze(ixz(:,13,:))));
quiver(X,Z,(squeeze(iz(x_mat,13,z_mat))),squeeze((ix(x_mat,13,z_mat))),'black')

axis([1 100 1 24])
shading interp
view(90,270)
daspect([1 1/10 1])
set(h,'edgealpha',0.2)
set(gca,'YTick',7:18)
set(gca,'YTickLabel',1:12)
set(gca,'XTick',1:10:100)
xaks=0:(1000*dz):(10000*dz);
set(gca,'XTickLabel',round(xaks))
xlabel('Avstand, z, over kilden [cm]','fontsize',12)
ylabel('Mikrofonposisjon i x-retning','fontsize',12)
%title('Intensitet zx-planet ved 5000Hz')
hold off